#define __SFR_OFFSET 0x00
#include "avr/io.h"

.global start
.global led

start:
  SBI   DDRB,5        ;set bit in the 5th DDR register of port B to 1 (output)
  RET

led:
  CPI   R24, 0x00     ;compare the value in register 24 passed as parameter to the function to 0x00
  BREQ  ledOFF
  SBI   PORTB,5       ;set bit in the 5th PORT B register to 1 (HIGH)
  RCALL myDelay
  RET

ledOFF:
  CBI   PORTB, 5      ;set bit in the 5th PORT B register to 0 (LOW)
  RCALL myDelay
  RET

.equ  delayVal, 65000         ;assign a value delayVal. Defines the actual delay

myDelay:
  LDI   R20, 200              ;initial value of the outer loop
outerLoop:
  LDI   R30, lo8(delayVal)    ;puts the low byte of delayVal into register R30
  LDI   R31, hi8(delayVal)    ;puts the high byte of delayVal into register R31
innerLoop:
  SBIW  R30, 1                ;subtract 1 to the 16-bits value in R30 and R31
  BRNE  innerLoop             ;jump to innerLoop: if delayVal is not equal to 0

  SUBI  R20, 1                ;subtract 1 from value present in R20
  BRNE  outerLoop
